/********************************************
Personal library of Cyril Roussillon
http://crteknologies.free.fr
cyril42e@gmail.com
2006-2007
*********************************************/

#include "cyril-timer.h"
#include "cyril-macro.h"
#include "cyril-std.h"


int INFO_INDENT = 0;
char BLANK[BLANK_S] = "                                                                                                                                                                                                       \0";
char TAB[TAB_S] = "\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\0";
int FN_SIZE = 0;
FILE *LOG_FILE = NULL;
int STOP_PROGRAM = 0;

double CUMUL_ALLOC = 0;
unsigned NB_ALLOC = 0;
double PREV_CUMUL_ALLOC = 0;

/**
exponentiation rapide (log n).
pour les flottants utiliser directement pow
sans doute pas plus rapide que pow, mais pour travailler en entiers c'est plus propre de rester en entiers
*/
/*
int power(int x, int n)
{
	int res = 1;
	while (n)
	{
		if (n%2) res *= x;
		n /= 2;
		x *= x;
	}
	return x;
}
*/


//////////////////////////////////////////////////////////////////
// initialisation programme
//////////////////////////////////////////////////////////////////
// void __() {}

#include <cyril-timer.h>


void initCyrilLib(unsigned int *seed, int filename_size, char *log)
{
	if (log == NULL) LOG_FILE = NULL; else 
	{
		LOG_FILE = fcreate(log, "wt");
		if (!LOG_FILE) WARN("log %s cannot be created", log);
	}

	gettimeofday(&ts.tv, &ts.tz);
	ts.startingValue = ts.tv.tv_sec;
	// si on se moque de la seed, on appelle avec NULL, si on veut l'imposer on donne la valeur, si on ne veut pas l'imposer mais rcuprer sa valeur on donne une variable contenant 0
	unsigned int myseed;
	if (seed == NULL || *seed == 0) myseed = ts.tv.tv_sec + ts.tv.tv_usec + getpid();	else myseed = *seed;
	if (seed != NULL && *seed == 0) *seed = myseed;
	srand(myseed);
	INFO("Random number generator initialized with seed %u", myseed); // for debug purpose
	
	for(int i = 0; i < BLANK_S; i++) BLANK[i] = ' '; BLANK[BLANK_S-1] = 0;
	INFO_INDENT = 0;
	if (filename_size <= 0) filename_size = 0;
	FN_SIZE = filename_size;
	
	STOP_PROGRAM = false;
}





